// ------------------------------------------------------------------------------------------------
//
//   Noise shader by Nash
//
// ------------------------------------------------------------------------------------------------

float rand(vec2 co)
{
	float a = 12.9898;
	float b = 78.233;
	float c = 43758.5453;
	float dt = dot(co.xy, vec2(a, b));
	float sn = mod(dt, 3.14);
	return fract(sin(sn) * c);
}

void main()
{
	vec2 uv = TexCoord;
	vec2 texSize = textureSize(InputTexture, 0);

	float px = texSize.x / 640;
	vec2 newUV = floor(uv * texSize / px) / texSize * px;

	float r = rand(newUV * timer);
	vec4 VI = texture(InputTexture, uv);
	VI = (VI * r) * 0.175 + VI * (1.0 - 0.175);
	FragColor = vec4(VI);
}
